"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// @ts-ignore: no types available.
const pirates = tslib_1.__importStar(require("pirates"));
const index_1 = require("./index");
function addHook(extension, options) {
    pirates.addHook((code, filePath) => index_1.transform(code, Object.assign({}, options, { filePath })), { exts: [extension] });
}
exports.addHook = addHook;
function registerJS() {
    addHook(".js", { transforms: ["imports", "flow", "jsx"] });
}
exports.registerJS = registerJS;
function registerJSX() {
    addHook(".jsx", { transforms: ["imports", "flow", "jsx"] });
}
exports.registerJSX = registerJSX;
function registerTS() {
    addHook(".ts", { transforms: ["imports", "typescript"] });
}
exports.registerTS = registerTS;
function registerTSX() {
    addHook(".tsx", { transforms: ["imports", "typescript", "jsx"] });
}
exports.registerTSX = registerTSX;
function registerTSLegacyModuleInterop() {
    addHook(".ts", {
        transforms: ["imports", "typescript"],
        enableLegacyTypeScriptModuleInterop: true,
    });
}
exports.registerTSLegacyModuleInterop = registerTSLegacyModuleInterop;
function registerTSXLegacyModuleInterop() {
    addHook(".tsx", {
        transforms: ["imports", "typescript", "jsx"],
        enableLegacyTypeScriptModuleInterop: true,
    });
}
exports.registerTSXLegacyModuleInterop = registerTSXLegacyModuleInterop;
function registerAll() {
    registerJS();
    registerJSX();
    registerTS();
    registerTSX();
}
exports.registerAll = registerAll;
